/*
 * SPI_Socket.h
 *
 *  Created on: Jul 12, 2020
 *      Author: a0489203
 */

#ifndef SPI_SOCKET_H_
#define SPI_SOCKET_H_
#include "TLC6983DMA.h"

extern uint8_t dmaTxData[33]; //Stores the data bytes to be sent
extern uint8_t dmaRxData[18]; //Stores the data bytes to be received

extern unsigned int dmaSyncFlag; //timeout flag





enum WRITE_COMMAND_ID{
    W_FC0 = 0xAA00,
    W_FC1,
    W_FC2,
    W_FC3,
    W_FC4,
    W_FC5,
    W_FC6,
    W_FC7,
    W_FC8,
    W_FC9,
    W_FC10,
    W_FC11,
    W_FC12,
    W_FC13,
    W_FC14,
    W_FC15,
    W_CHIP_INDEX = 0xAA10,
    W_VSYNC = 0XAAF0,
    W_MPSM = 0XAA90,
    W_SBY_EN = 0XAAB0,
    W_SBY_CLR = 0XAAB1,
    W_SOFT_RESET = 0XAA80,
    W_SRAM = 0xAA30
};

enum READ_COMMAND_ID{
    R_FC0 = 0xAA60,
    R_FC1,
    R_FC2,
    R_FC3,
    R_FC4,
    R_FC5,
    R_FC6,
    R_FC7,
    R_FC8,
    R_FC9,
    R_FC10,
    R_FC11,
    R_FC12,
    R_FC13,
    R_FC14,
    R_FC15,
    R_FC16 = 0xAAA0,
    R_FC17,
    R_FC18,
    R_FC19,
    R_FC20,
    R_FC21,
    R_CHIP_INDEX = 0xAA70,
};

//Control bits for FC0


void SPI_write(uint16_t headbytes, uint16_t *databytes, uint8_t length);
void SPI_read(uint16_t headbytes);




#endif /* SPI_SOCKET_H_ */
