#include <msp430.h> 
#include "TLC6983DMA.h"
#include "SPI_Socket.h"
#include "delayTimer.h"
#include "img_TI_LOGO.h"


void logo_gen(uint16_t arrB[32][32],uint16_t arrG[32][32],uint16_t arrR[32][32]);
void logo_gen1(uint16_t arrB1[16][16], uint16_t arrG1[16][16], uint16_t arrR1[16][16]);
int lsd_detection();
int lod_detection();

uint8_t dmaTxData[33]; //Stores the data bytes to be sent
uint8_t dmaRxData[18]; //Stores the data bytes to be received
uint16_t img_R[32][32];
uint16_t img_G[32][32];
uint16_t img_B[32][32];
uint16_t img_R1[16][16];
uint16_t img_G1[16][16];
uint16_t img_B1[16][16];
//volatile uint16_t showImg[32][96];
uint16_t jj;
uint16_t time_count;
uint16_t time_count1;
//lsd function
uint16_t lsd_line_cmd;
uint16_t lsd_line_cmd_l;
uint16_t lsd_line_cmd_h;
uint16_t lsd_ch[3];
uint16_t lsd_line_warn[2];
uint8_t lsd_flag;
//lod function
uint16_t lod_line_cmd;
uint16_t lod_line_cmd_l;
uint16_t lod_line_cmd_h;
uint16_t lod_ch[3];
uint16_t lod_line_warn[2];
uint8_t lod_flag;

unsigned int dmaSyncFlag; //timeout flag

/* Function Name: setData
 *
 * Purpose: Set data send buffer.
 *
 * Parameters:
 * data -> The pointer of data send buffer.
 * high, mid, low -> Data bytes, MSB first.
 * bias -> Bias in the date send buffer.
 *
 */
void setData(uint16_t *data, uint16_t high, uint16_t mid, uint16_t low, uint8_t bias){
    data[0 + bias] = high;
    data[1 + bias] = mid;
    data[2 + bias] = low;
}


uint16_t count = 0;
uint8_t flag = 0;

void delay(uint16_t time){
    uint16_t i;

    jj = 0;
    for(i = time ; i > 0 ; --i){
        ++jj;
    }
        //for(j = time ; j > 0 ; --j);
}

/**
 * main.c
 */
int main(void)
{
    uint16_t data[6] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};//Data send buffer
    uint8_t i = 0, j = 0, k=0;//Loop index
    uint16_t count=0;
    uint16_t R = 0;
    uint16_t G = 0;
    uint16_t B = 0;

	WDTCTL = WDTPW | WDTHOLD;	// stop watchdog timer


	__bis_SR_register(GIE); //enable interrupt
	ucsInitial(); //system clock initial
	timerInitial(); //
	spiInitial();
	dmaInitial();


	//logo_gen(logo_B, logo_G, logo_R);
	//SPI_write(W_SBY_EN, data, 0);


	SPI_write(W_CHIP_INDEX, data, 0);//Write chip index.
	SPI_write(W_CHIP_INDEX, data, 0);//Write chip index.

	//TLC6984 32*32 1920Hz flash 30Hz frame
    setData(data, 0x2001, 0x98DF, 0x0101, 0);//8 x 5MHz= 40Mhz, 64 sub-periods, totally 39.321ms, about 25.43Hz
    SPI_write(W_FC0, data, 3);

    setData(data, 0x0060, 0x0094, 0xA7FF, 0);//576 x GCLK for each segment, each sub-period is totally 409.6us
    SPI_write(W_FC1, data, 3);

    setData(data, 0x0B80, 0x0000, 0x0666, 0);//
    SPI_write(W_FC2, data, 3);

    //setData(data, 0x0183, 0xFFFF, 0xFF82, 0);//device2
    setData(data, 0x0023, 0xFBFB, 0xFB80, 0);//device1
    SPI_write(W_FC3, data, 3);

    setData(data, 0x0800, 0x0540, 0x4006, 0);//
    SPI_write(W_FC4, data, 3);

	//TLC6984-16*16-0923
   /* setData(data, 0x2001, 0xF8CF, 0x1100, 0);//8 x 5MHz= 40Mhz, 64 sub-periods, totally 39.321ms, about 25.43Hz
    SPI_write(W_FC0, data, 3);

    setData(data, 0x0020, 0x0094, 0xA7FF, 0);//576 x GCLK for each segment, each sub-period is totally 409.6us
    SPI_write(W_FC1, data, 3);

    setData(data, 0x0380, 0x0000, 0x0666, 0);//
    SPI_write(W_FC2, data, 3);

    setData(data, 0x0023, 0xFFFF, 0xFF00, 0);//
    SPI_write(W_FC3, data, 3);

    setData(data, 0x0800, 0x0540, 0x0002, 0);//
    SPI_write(W_FC4, data, 3);*/

    //PROGRAMMABLE SCAN
    //setData(data, 0x1C61, 0x440C, 0x0042, 0);
    //SPI_write(W_FC6, data, 3);

    SPI_write(W_VSYNC, data, 0);
    //logo_gen(img_B, img_G, img_R);    logo_gen1(img_B1, img_G1, img_R1);


/*	while(1){
	    if(time_count > 24) time_count = 10;
	    if(time_count < 10){
	        for(i = 0 ; i < 32 ; ++i){
                for(j = 0 ; j < 16 ; ++j){
                    setData(data, img_B[i][j], img_G[i][j], img_R[i][j], 0);
                    setData(data, img_B[i][j + 16], img_G[i][j + 16], img_R[i][j + 16], 3);
                    SPI_write(W_SRAM, data, 6);
                }
            }
	        SPI_write(W_VSYNC, data, 0);
	    }
	    else if(time_count >= 10){
	        for(i = 0 ; i < 32 ; ++i){
                for(j = 0 ; j < 32 ; ++j){
                    R = img[(time_count - 10)/2][i][j];
                    G = img[(time_count - 10)/2][i][j + 32];
                    B = img[(time_count - 10)/2][i][j + 64];
                    //showImg[i][j] = img[time_count/2][i][j];
                    img_R[i][j] = (R) > 50000 ? (R) : 1510;//3020
                    img_G[i][j] = (G) > 50000 ? (G) : 4915;
                    img_B[i][j] = (B) > 50000 ? (B) : 3712;
                }
            }
	        for(i = 0 ; i < 32 ; ++i){
                for(j = 0 ; j < 16 ; ++j){
                    setData(data, img_B[i][j], img_G[i][j], img_R[i][j], 0);
                    setData(data, img_B[i][j + 16], img_G[i][j + 16], img_R[i][j + 16], 3);
                    SPI_write(W_SRAM, data, 6);
                }
            }
            SPI_write(W_VSYNC, data, 0);
	    }
	    //delay(1000);
	    ++time_count;
	}*/
    while(1){
                count=count+1;
                for(i = 0 ; i < 32 ; ++i){
                               for(j = 0 ; j < 16 ; ++j){

                setData(data, 0x8000, 0x8000, 0x8000, 0);
                setData(data, 0x8000, 0x8000, 0x8000, 3);
                SPI_write(W_SRAM, data, 6);}
                }
                //SPI_write(W_MPSM, data, 0);
                SPI_write(W_VSYNC, data, 0);
                //lsd_detection();
                //lod_detection();

            }
        //count=0;

	return 0;
}

void logo_gen1(uint16_t arrB1[16][16],uint16_t arrG1[16][16],uint16_t arrR1[16][16])
{
    uint8_t i,j;
    for(i=0;i<1;i++){
        for(j=0;j<16;j++){
            arrB1[i][j]=0x3FFF;
            arrG1[i][j]=0x3FFF;
            arrR1[i][j]=0x3FFF;
        }
    }
    for(i=1;i<4;i++){
        for(j=0;j<16;j++){
            arrB1[i][j]=0;
            arrG1[i][j]=0;
            arrR1[i][j]=0;
        }
    }
    for(i=4;i<6;i++){
        for(j=0;j<16;j++){
            arrB1[i][j]=0x3FFF;
            arrG1[i][j]=0x3FFF;
            arrR1[i][j]=0x3FFF;
        }
    }
    for(i=6;i<8;i++){
        for(j=0;j<16;j++){
            arrB1[i][j]=0;
            arrG1[i][j]=0;
            arrR1[i][j]=0;
        }
    }
    for(i=8;i<11;i++){
        for(j=0;j<16;j++){
            arrB1[i][j]=0x3FFF;
            arrG1[i][j]=0x3FFF;
            arrR1[i][j]=0x3FFF;
        }
    }
    for(i=11;i<12;i++){
        for(j=0;j<16;j++){
            arrB1[i][j]=0;
            arrG1[i][j]=0;
            arrR1[i][j]=0;
        }
    }
    for(i=12;i<16;i++){
        for(j=0;j<16;j++){
            arrB1[i][j]=0x3FFF;
            arrG1[i][j]=0x3FFF;
            arrR1[i][j]=0x3FFF;
        }
    }
}

void logo_gen(uint16_t arrB[32][32],uint16_t arrG[32][32],uint16_t arrR[32][32])
{
    uint8_t i,j;
    for(i=0;i<32;i++)
    {
        for(j=0;j<32;j++)
        {
            arrB[i][j]=0;
            arrG[i][j]=0;
            arrR[i][j]=0x1FFF;
        }
    }

    for(i=6;i<19;i++)
    {
        for(j=10;j<15;j++)
        {
            arrB[i][j]=0x3FFF;
            arrG[i][j]=0x3FFF;
            arrR[i][j]=0x3FFF;
        }
    }



    for(i=10;i<20;i++)
    {
        for(j=20;j<25;j++)
        {
            arrB[i][j]=0x3FFF;
            arrG[i][j]=0x3FFF;
            arrR[i][j]=0x3FFF;
        }
    }
    for(i=14;i<20;i++)
    {
        for(j=7;j<10;j++)
        {
            arrB[i][j]=0x3FFF;
            arrG[i][j]=0x3FFF;
            arrR[i][j]=0x3FFF;
        }
    }
    for(i=14;i<19;i++)
    {
        for(j=16;j<18;j++)
        {
            arrB[i][j]=0x3FFF;
            arrG[i][j]=0x3FFF;
            arrR[i][j]=0x3FFF;
        }
    }

    for(i=22;i<26;i++)
    {
        for(j=15;j<19;j++)
        {
            arrB[i][j]=0x3FFF;
            arrG[i][j]=0x3FFF;
            arrR[i][j]=0x3FFF;
        }
    }

    arrR[7][18]=0x3FFF;
    arrR[7][19]=0x3FFF;
    arrR[8][18]=0x3FFF;
    arrR[8][19]=0x3FFF;

    arrR[10][15]=0x3FFF;
    arrR[11][15]=0x3FFF;

    arrG[7][18]=0x3FFF;
    arrG[7][19]=0x3FFF;
    arrG[8][18]=0x3FFF;
    arrG[8][19]=0x3FFF;

    arrG[10][15]=0x3FFF;
    arrG[11][15]=0x3FFF;

    arrB[7][18]=0x3FFF;
    arrB[7][19]=0x3FFF;
    arrB[8][18]=0x3FFF;
    arrB[8][19]=0x3FFF;

    arrB[10][15]=0x3FFF;
    arrB[11][15]=0x3FFF;

    for(i=10;i<14;i++)
    {
        for(j=17;j<19;j++)
        {
            arrB[i][j]=0x3FFF;
            arrG[i][j]=0x3FFF;
            arrR[i][j]=0x3FFF;
        }
    }
    for(i=14;i<19;i++)
    {
        for(j=16;j<18;j++)
        {
            arrB[i][j]=0x3FFF;
            arrG[i][j]=0x3FFF;
            arrR[i][j]=0x3FFF;
        }
    }
    arrR[14][4]=0x3FFF;
    arrR[14][5]=0x3FFF;
    arrR[14][6]=0x3FFF;
    arrR[15][4]=0x3FFF;
    arrR[15][5]=0x3FFF;
    arrR[15][6]=0x3FFF;
    arrR[16][5]=0x3FFF;
    arrR[16][6]=0x3FFF;
    arrR[17][6]=0x3FFF;

    arrR[20][8]=0x3FFF;
    arrR[20][9]=0x3FFF;

    arrR[19][10]=0x3FFF;
    arrR[19][11]=0x3FFF;
    arrR[19][12]=0x3FFF;
    arrR[19][13]=0x3FFF;

    arrR[20][12]=0x3FFF;
    arrR[20][13]=0x3FFF;

    arrR[21][13]=0x3FFF;
    arrR[21][14]=0x3FFF;
    arrR[22][13]=0x3FFF;
    arrR[22][14]=0x3FFF;
    arrR[23][14]=0x3FFF;

    arrR[26][16]=0x3FFF;
    arrR[26][17]=0x3FFF;
    arrR[26][18]=0x3FFF;
    arrR[26][19]=0x3FFF;

    arrR[27][17]=0x3FFF;
    arrR[27][18]=0x3FFF;
    arrR[27][19]=0x3FFF;

    arrR[21][19]=0x3FFF;
    arrR[22][19]=0x3FFF;
    arrR[23][19]=0x3FFF;

    arrR[15][19]=0x3FFF;
    arrR[16][19]=0x3FFF;
    arrR[17][19]=0x3FFF;
    arrR[18][19]=0x3FFF;

    arrR[20][20]=0x3FFF;
    arrR[21][20]=0x3FFF;
    arrR[22][20]=0x3FFF;

    arrR[20][21]=0x3FFF;
    arrR[21][21]=0x3FFF;

    arrR[20][22]=0x3FFF;

    arrR[15][25]=0x3FFF;
    arrR[16][25]=0x3FFF;
    arrR[17][25]=0x3FFF;
    arrR[18][25]=0x3FFF;
    arrR[19][25]=0x3FFF;

    //---------------------
    arrG[14][4]=0x3FFF;
    arrG[14][5]=0x3FFF;
    arrG[14][6]=0x3FFF;
    arrG[15][4]=0x3FFF;
    arrG[15][5]=0x3FFF;
    arrG[15][6]=0x3FFF;
    arrG[16][5]=0x3FFF;
    arrG[16][6]=0x3FFF;
    arrG[17][6]=0x3FFF;

    arrG[20][8]=0x3FFF;
    arrG[20][9]=0x3FFF;

    arrG[19][10]=0x3FFF;
    arrG[19][11]=0x3FFF;
    arrG[19][12]=0x3FFF;
    arrG[19][13]=0x3FFF;

    arrG[20][12]=0x3FFF;
    arrG[20][13]=0x3FFF;

    arrG[21][13]=0x3FFF;
    arrG[21][14]=0x3FFF;
    arrG[22][13]=0x3FFF;
    arrG[22][14]=0x3FFF;
    arrG[23][14]=0x3FFF;

    arrG[26][16]=0x3FFF;
    arrG[26][17]=0x3FFF;
    arrG[26][18]=0x3FFF;
    arrG[26][19]=0x3FFF;

    arrG[27][17]=0x3FFF;
    arrG[27][18]=0x3FFF;
    arrG[27][19]=0x3FFF;

    arrG[21][19]=0x3FFF;
    arrG[22][19]=0x3FFF;
    arrG[23][19]=0x3FFF;

    arrG[15][19]=0x3FFF;
    arrG[16][19]=0x3FFF;
    arrG[17][19]=0x3FFF;
    arrG[18][19]=0x3FFF;

    arrG[20][20]=0x3FFF;
    arrG[21][20]=0x3FFF;
    arrG[22][20]=0x3FFF;

    arrG[20][21]=0x3FFF;
    arrG[21][21]=0x3FFF;

    arrG[20][22]=0x3FFF;

    arrG[15][25]=0x3FFF;
    arrG[16][25]=0x3FFF;
    arrG[17][25]=0x3FFF;
    arrG[18][25]=0x3FFF;
    arrG[19][25]=0x3FFF;
    //---------------------
    arrB[14][4]=0x3FFF;
    arrB[14][5]=0x3FFF;
    arrB[14][6]=0x3FFF;
    arrB[15][4]=0x3FFF;
    arrB[15][5]=0x3FFF;
    arrB[15][6]=0x3FFF;
    arrB[16][5]=0x3FFF;
    arrB[16][6]=0x3FFF;
    arrB[17][6]=0x3FFF;

    arrB[20][8]=0x3FFF;
    arrB[20][9]=0x3FFF;

    arrB[19][10]=0x3FFF;
    arrB[19][11]=0x3FFF;
    arrB[19][12]=0x3FFF;
    arrB[19][13]=0x3FFF;

    arrB[20][12]=0x3FFF;
    arrB[20][13]=0x3FFF;

    arrB[21][13]=0x3FFF;
    arrB[21][14]=0x3FFF;
    arrB[22][13]=0x3FFF;
    arrB[22][14]=0x3FFF;
    arrB[23][14]=0x3FFF;

    arrB[26][16]=0x3FFF;
    arrB[26][17]=0x3FFF;
    arrB[26][18]=0x3FFF;
    arrB[26][19]=0x3FFF;

    arrB[27][17]=0x3FFF;
    arrB[27][18]=0x3FFF;
    arrB[27][19]=0x3FFF;

    arrB[21][19]=0x3FFF;
    arrB[22][19]=0x3FFF;
    arrB[23][19]=0x3FFF;

    arrB[15][19]=0x3FFF;
    arrB[16][19]=0x3FFF;
    arrB[17][19]=0x3FFF;
    arrB[18][19]=0x3FFF;

    arrB[20][20]=0x3FFF;
    arrB[21][20]=0x3FFF;
    arrB[22][20]=0x3FFF;

    arrB[20][21]=0x3FFF;
    arrB[21][21]=0x3FFF;

    arrB[20][22]=0x3FFF;

    arrB[15][25]=0x3FFF;
    arrB[16][25]=0x3FFF;
    arrB[17][25]=0x3FFF;
    arrB[18][25]=0x3FFF;
    arrB[19][25]=0x3FFF;



    arrR[12][14]=0x1FFF;
    arrR[13][14]=0x1FFF;
    arrR[14][14]=0x1FFF;
    arrR[12][20]=0x1FFF;
    arrR[13][20]=0x1FFF;
    arrR[14][20]=0x1FFF;

    arrG[12][14]=0;
    arrG[13][14]=0;
    arrG[14][14]=0;
    arrG[12][20]=0;
    arrG[13][20]=0;
    arrG[14][20]=0;

    arrB[12][14]=0;
    arrB[13][14]=0;
    arrB[14][14]=0;
    arrB[12][20]=0;
    arrB[13][20]=0;
    arrB[14][20]=0;
}

int lsd_detection()
{
    uint8_t i, j=0, k=0, q=0;
    uint16_t data[6] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

    lsd_line_warn[0]=0;
    lsd_line_warn[1]=0;
    lsd_flag=0;
    for(i=0; i<3; i++){
        lsd_ch[i]=0x0000;
    }
    lsd_line_cmd_l=0x0001;
    lsd_line_cmd_h=0x0001;
    lsd_line_cmd=0;

    delay(500);
    SPI_read(R_FC19);
    lsd_line_warn[1]= dmaRxData[7] & 0x01;
    lsd_line_warn[1]= (lsd_line_warn[1]<<8) & 0xFF00 | dmaRxData[8];
    lsd_line_warn[1]= (lsd_line_warn[1]<<7) & 0xFF80 | (dmaRxData[9]>>1) & 0x7F;
    lsd_line_warn[0]= dmaRxData[10];
    lsd_line_warn[0]= lsd_line_warn[0]<<8 | dmaRxData[11];

    for(i=0; i<16;i++){
        if(lsd_line_warn[0] & lsd_line_cmd_l)
            lsd_line_cmd=i;
        lsd_line_cmd_l=lsd_line_cmd_l<<1;
    }
    for(i=0; i<16;i++){
        if(lsd_line_warn[1] & lsd_line_cmd_h )
            lsd_line_cmd=i+16;
        lsd_line_cmd_h=lsd_line_cmd_h<<1;
    }

        setData(data, 0x0000, 0x0000, lsd_line_cmd, 0);
        SPI_write(W_FC15, data, 3);
        delay(1000);
        SPI_read(R_FC21);
        lsd_ch[2]= dmaRxData[5] & 0x02;
        lsd_ch[2]= (lsd_ch[2]<<8) & 0xFF00 | dmaRxData[6];
        lsd_ch[2]= (lsd_ch[2]<<6) & 0xFFC0 | (dmaRxData[7]>>2);
        lsd_ch[1]= dmaRxData[7] & 0x01;
        lsd_ch[1]= (lsd_ch[1]<<8) & 0xFF00 | dmaRxData[8];
        lsd_ch[1]= (lsd_ch[1]<<7) & 0xFF80 | (dmaRxData[9]>>1) & 0x7F;
        lsd_ch[0]= dmaRxData[10];
        lsd_ch[0]= lsd_ch[0]<<8 | dmaRxData[11];
   /* while(lsd_flag == 0 & (lsd_line_warn[0] | lsd_line_warn[1] != 0)){
        if(lsd_line_warn[0] != 0){
            lsd_flag |= lsd_line_warn[0] & 0x01;
            lsd_line_warn[0] = lsd_line_warn[0] >> 1;
            lsd_line_cmd_l= lsd_line_cmd_l + 1;
        }else{
            lsd_flag |= lsd_line_warn[1] & 0x01;
            lsd_line_warn[1] = lsd_line_warn[1] >> 1;
            lsd_line_cmd_h= lsd_line_cmd_h + 1;
        }
    }
    lsd_line_cmd=lsd_line_cmd_l + lsd_line_cmd_h;
    if(lsd_line_cmd != 0){
    setData(data, 0x0000, 0x0000, lsd_line_cmd-1, 0);
    SPI_write(W_FC11, data, 3);
    delay(100);
    SPI_read(R_FC15);
    for(i=0; i<3; ++i){
        lsd_ch[i]=dmaRxData[i];
    }
    }*/
}

int lod_detection()
{
    uint8_t i, j=0, k=0, q=0;
    uint16_t data[6] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

    lod_line_warn[0]=0;
    lod_line_warn[1]=0;
    lod_flag=0;
    for(i=0; i<3; i++){
        lod_ch[i]=0x0000;
    }
    lod_line_cmd_l=0x0001;
    lod_line_cmd_h=0x0001;
    lod_line_cmd=0;
    delay(500);
    SPI_read(R_FC17);
   // SPI_read(R_FC16);
    lod_line_warn[1]= dmaRxData[7] & 0x01;
    lod_line_warn[1]= (lod_line_warn[1]<<8) & 0xFF00 | dmaRxData[8];
    lod_line_warn[1]= (lod_line_warn[1]<<7) & 0xFF80 | (dmaRxData[9]>>1) & 0x7F;
    lod_line_warn[0]= dmaRxData[10];
    lod_line_warn[0]= (lod_line_warn[0]<<8) & 0xFF00 | dmaRxData[11];

    for(i=0; i<16;i++){
        if(lod_line_warn[0] == lod_line_cmd_l)
            lod_line_cmd=i;
        lod_line_cmd_l=lod_line_cmd_l<<1;
    }
    for(i=0; i<16;i++){
        if(lod_line_warn[1] == lod_line_cmd_h)
            lod_line_cmd=i+16;
        lod_line_cmd_h=lod_line_cmd_h<<1;
    }

    setData(data, 0x0000, 0x0000, lod_line_cmd, 0);
    SPI_write(W_FC14, data, 3);
    SPI_read(R_FC20);
    lod_ch[2]= dmaRxData[5] & 0x02;
    lod_ch[2]= (lod_ch[2]<<8) & 0xFF00 | dmaRxData[6];
    lod_ch[2]= (lod_ch[2]<<6) & 0xFFC0 | (dmaRxData[7]>>2);
    lod_ch[1]= dmaRxData[7] & 0x01;
    lod_ch[1]= (lod_ch[1]<<8) & 0xFF00 | dmaRxData[8];
    lod_ch[1]= (lod_ch[1]<<7) & 0xFF80 | (dmaRxData[9]>>1) & 0x7F;
    lod_ch[0]= dmaRxData[10];
    lod_ch[0]= lod_ch[0]<<8 | dmaRxData[11];
    }
